<html lang="en">
<head>
<title>Default Superclass - Enhanced Implementation of Emacs Interpreted Objects</title>
<meta http-equiv="Content-Type" content="text/html">
<meta name="description" content="Enhanced Implementation of Emacs Interpreted Objects">
<meta name="generator" content="makeinfo 4.8">
<link title="Top" rel="start" href="index.html#Top">
<link rel="prev" href="Building-Classes.html#Building-Classes" title="Building Classes">
<link rel="next" href="Making-New-Objects.html#Making-New-Objects" title="Making New Objects">
<link href="http://www.gnu.org/software/texinfo/" rel="generator-home" title="Texinfo Homepage">
<meta http-equiv="Content-Style-Type" content="text/css">
<style type="text/css"><!--
  pre.display { font-family:inherit }
  pre.format  { font-family:inherit }
  pre.smalldisplay { font-family:inherit; font-size:smaller }
  pre.smallformat  { font-family:inherit; font-size:smaller }
  pre.smallexample { font-size:smaller }
  pre.smalllisp    { font-size:smaller }
  span.sc    { font-variant:small-caps }
  span.roman { font-family:serif; font-weight:normal; } 
  span.sansserif { font-family:sans-serif; font-weight:normal; } 
--></style>
</head>
<body>
<div class="node">
<p>
<a name="Default-Superclass"></a>
Next:&nbsp;<a rel="next" accesskey="n" href="Making-New-Objects.html#Making-New-Objects">Making New Objects</a>,
Previous:&nbsp;<a rel="previous" accesskey="p" href="Building-Classes.html#Building-Classes">Building Classes</a>,
Up:&nbsp;<a rel="up" accesskey="u" href="index.html#Top">Top</a>
<hr>
</div>

<!-- node-name,  next,  previous,  up -->
<h2 class="chapter">4 Default Superclass</h2>

<p>All defined classes, if created as a superclass (With no specified
parent class) will actually inherit from a special superclass stored in
<code>eieio-default-superclass</code>.  This superclass is actually quite
simple, but with it, certain default methods or attributes can be added
to all objects at any time, without updating their code in the future
(If there is a change).  In CLOS, this would be named
<code>STANDARD-CLASS</code> and is aliased.

   <p>Currently, the default superclass is defined as follows:

<pre class="example">     (defclass eieio-default-superclass nil
       nil
       )
      "Default class used as parent class for superclasses.  It's
     slots are automatically adopted by such superclasses but not stored
     in the `parent' slot.  When searching for attributes or methods, when
     the last parent is found, the search will recurse to this class.")
</pre>
   <p>When creating an object of any type, you can use it's constructor, or
<code>make-instance</code>.  This, in turns calls the method
<code>initialize-instance</code>, which then calls the method
<code>shared-initialize</code>.

<div class="defun">
&mdash; Function: <b>initialize-instance</b><var> obj &amp;rest slots<a name="index-initialize_002dinstance-4"></a></var><br>
<blockquote><p>Initialize <var>obj</var>.  Sets slots of <var>obj</var> with <var>slots</var> which
is a list of name/value pairs.  These are actually just passed to
<code>shared-initialize</code>. 
</p></blockquote></div>

<div class="defun">
&mdash; Function: <b>shared-initialize</b><var> obj &amp;rest slots<a name="index-shared_002dinitialize-5"></a></var><br>
<blockquote><p>Sets slots of <var>obj</var> with <var>slots</var> which is a list of name/value
pairs. 
</p></blockquote></div>

   <p>These methods are used to override errors:

<div class="defun">
&mdash; Function: <b>slot-missing</b><var> object slot operation &amp;optional new-value<a name="index-slot_002dmissing-6"></a></var><br>
<blockquote><p>This method is called when there is an attempt to access a slot that
does not exist for a given object.  The default method signals an error
of type <code>invalid-slot-name</code>.  See <a href="Signals.html#Signals">Signals</a>.

        <p>You may override this behavior, but it is not expected to return in the
current implementation.

        <p>This function takes arguments in a different order than in CLOS. 
</p></blockquote></div>

<div class="defun">
&mdash; Function: <b>slot-unbound</b><var> object class slot-name fn<a name="index-slot_002dunbound-7"></a></var><br>
<blockquote><p>This method is called when there is an attempt to access a slot that is
not bound.  This will throw an <code>unbound-slot</code> signal.  If
overridden it's return value will be returned from the function
attempting to reference its value. 
</p></blockquote></div>

<div class="defun">
&mdash; Function: <b>no-applicable-method</b><var> object method<a name="index-no_002dapplicable_002dmethod-8"></a></var><br>
<blockquote><p>This method is called when there is an attempt to call a method on
<var>object</var> when there is no method to call.  The default method throws
a <code>no-method-definition</code> signal.  The return value of this function
becomes the return value of the non-existent method. 
</p></blockquote></div>

<div class="defun">
&mdash; Function: <b>no-next-method</b><var> object args<a name="index-no_002dnext_002dmethod-9"></a></var><br>
<blockquote><p>This method is called when an attempt to call <code>call-next-method</code> is
made, and there is no next method that can be called.    The return
value becomes the return value of <code>call-next-method</code>. 
</p></blockquote></div>

   <p>Additional useful methods are:

<div class="defun">
&mdash; Function: <b>clone</b><var> obj &amp;rest params<a name="index-clone-10"></a></var><br>
<blockquote><p>Make a deep copy of <var>obj</var>.  Once this copy is made, make
modifications specified by <var>params</var>.  <var>params</var> uses the same
format as the <var>slots</var> of <code>initialize-instance</code>.  The only
other change is to modify the name with an incrementing numeric. 
</p></blockquote></div>

<div class="defun">
&mdash; Function: <b>object-print</b><var> obj &amp;rest strings<a name="index-object_002dprint-11"></a></var><br>
<blockquote><p>Construct a printing lisp symbol for <var>OBJ</var>.  This would look like:
     <pre class="example">           #&lt;class-name "objname"&gt;
     </pre>
        <p>STRINGS are additional parameters passed in by overloading functions to
add more data into the printing abbreviation.

     <pre class="example">          (defclass data-object ()
             (value)
             "Object containing one data slot.")
          
          (defmethod object-print ((this data-object) &amp;optional strings)
            "Return a string with a summary of the data object as part of the name."
            (apply 'call-next-method this
          	 (cons (format " value: %s" (render this)) strings)))
     </pre>
        <p>here is what some output could look like:
     <pre class="example">          (object-print test-object)
             =&gt; #&lt;data-object test-object value: 3&gt;
     </pre>
        </blockquote></div>

<div class="defun">
&mdash; Function: <b>object-write</b><var> obj &amp;optional comment<a name="index-object_002dwrite-12"></a></var><br>
<blockquote><p>Write <var>obj</var> onto a stream in a readable fashion.  The resulting
output will be lisp code which can be used with <code>read</code> and
<code>eval</code> to recover the object.  Only slots with <code>:initarg</code>s
are written to the stream. 
</p></blockquote></div>

   </body></html>

